﻿using Monorail.DrawningObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Monorail.Generics
{
    internal class MonorailCompareByType : IComparer<DrawningMonorail?>
    {
        public int Compare(DrawningMonorail? x, DrawningMonorail? y)
        {
            if (x == null || x.EntityMonorail == null)
                throw new ArgumentNullException(nameof(x));

            if (y == null || y.EntityMonorail == null)
                throw new ArgumentNullException(nameof(y));

            if(x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            var speedCompare = x.EntityMonorail.Speed.CompareTo(y.EntityMonorail.Speed);

            if (speedCompare != 0)
                return speedCompare;

            return x.EntityMonorail.Weight.CompareTo(y.EntityMonorail.Weight);
        }
    }
}
